//
//  AQPlayFileModel2.h
//  AudioQueuePlayFile
//
//  Created by John Geelen on 28-06-11.
//  Copyright 2011 XLNT AT. All rights reserved.
//
//	Derived from Apple's example program AudioQueueTools.
//	The application icon is from Vincent Garnier http://benjigarner.deviantart.com/art/Fruity-Apples-80805804
//
//	OSX10.6 and XCODE 4.0.1
//
/*
 Disclaimer: IMPORTANT: 
 This JG Electronics software is supplied to you by JG Electronics as FREE AND OPEN SOURCE SOFTWARE. 
 
 The JG Electronics Software is provided by JG Electronics on an "AS IS" basis.
 JG ELECTRONICS MAKES NO WARRANTIES, EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION
 THE IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY AND FITNESS
 FOR A PARTICULAR PURPOSE, REGARDING THE JG ELECTRONICS SOFTWARE OR ITS USE AND
 OPERATION ALONE OR IN COMBINATION WITH YOUR PRODUCTS.
 
 IN NO EVENT SHALL JG ELECTRONICS BE LIABLE FOR ANY SPECIAL, INDIRECT, INCIDENTAL
 OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) ARISING IN ANY WAY OUT OF THE USE, REPRODUCTION,
 MODIFICATION AND/OR DISTRIBUTION OF THE JG ELECTRONICS SOFTWARE, HOWEVER CAUSED
 AND WHETHER UNDER THEORY OF CONTRACT, TORT (INCLUDING NEGLIGENCE),
 STRICT LIABILITY OR OTHERWISE, EVEN IF JG ELECTRONICS HAS BEEN ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.
 */
#import <Foundation/Foundation.h>
#import <CoreAudio/CoreAudio.h>
#import "AudioToolbox/AudioToolbox.h"
#import "AudioUnit/AudioUnit.h"

#define kNumberBuffers		3

@interface AQPlayFileModel2 : NSObject {
@private
	AudioFileID						mAudioFile;
	AudioStreamBasicDescription		mDataFormat;
	AudioChannelLayout *			mChannelLayout;
	UInt32							mChannelLayoutSize;
	AudioQueueRef					mQueue;
	AudioQueueBufferRef				mBuffers[kNumberBuffers];
	SInt64							mCurrentPacket;
	UInt32							mNumPacketsToRead;
	AudioStreamPacketDescription *	mPacketDescs;
	bool							mDone;
}

- (UInt32)pfCalculateBytesForTime:(AudioStreamBasicDescription)inDesc maxPacketSize:(UInt32)inMaxPacketSize seconds:(Float64)inSeconds;
- (BOOL)pfConfigureAudioFile2:(CFURLRef)inURL;
- (void)fpSetamplitude:(float)amplFlt;
- (BOOL)pfStartPlayBack;
- (BOOL)pfStopPlayBack;

@end
